/// @cond EO_CXX_EO_IMPL

inline void elm::radio::group_add(::elm::radio group_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_radio_group_add(::efl::eolian::to_c(group_)));
}

inline int elm::radio::state_value_get() const
{
   int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_radio_state_value_get());
   return _tmp_ret;
}

inline void elm::radio::state_value_set(int value_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_radio_state_value_set(value_));
}

inline int elm::radio::value_get() const
{
   int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_radio_value_get());
   return _tmp_ret;
}

inline void elm::radio::value_set(int value_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_radio_value_set(value_));
}

inline void elm::radio::value_pointer_set(int * valuep_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_radio_value_pointer_set(valuep_));
}

inline ::evas::object elm::radio::selected_object_get() const
{
   Evas_Object * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_radio_selected_object_get());
   return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::radio::group_add(::elm::radio group_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_radio_group_add(::efl::eolian::to_c(group_)));
}

inline int eo_cxx::elm::radio::state_value_get() const
{
   int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_radio_state_value_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::radio::state_value_set(int value_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_radio_state_value_set(value_));
}

inline int eo_cxx::elm::radio::value_get() const
{
   int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_radio_value_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::radio::value_set(int value_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_radio_value_set(value_));
}

inline void eo_cxx::elm::radio::value_pointer_set(int * valuep_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_radio_value_pointer_set(valuep_));
}

inline ::evas::object eo_cxx::elm::radio::selected_object_get() const
{
   Evas_Object * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_radio_selected_object_get());
   return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::eo_cxx::elm::radio::operator ::elm::radio() const
{
   return *static_cast<::elm::radio const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::radio::operator ::elm::radio&()
{
   return *static_cast<::elm::radio*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::radio::operator ::elm::radio const&() const
{
   return *static_cast<::elm::radio const*>(static_cast<void const*>(this));
}

template <typename T>
void elm_radio_group_add_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Radio * group_)
{
   try
      {
         static_cast<T*>(self->this_)->group_add(::efl::eolian::to_cxx<::elm::radio>(group_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
int elm_radio_state_value_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->state_value_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         int _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_radio_state_value_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int value_)
{
   try
      {
         static_cast<T*>(self->this_)->state_value_set(value_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
int elm_radio_value_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->value_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         int _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_radio_value_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int value_)
{
   try
      {
         static_cast<T*>(self->this_)->value_set(value_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_radio_value_pointer_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int * valuep_)
{
   try
      {
         static_cast<T*>(self->this_)->value_pointer_set(valuep_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::evas::object elm_radio_selected_object_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->selected_object_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Evas_Object * _tmp_ret{};
         return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::radio >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::layout >::template type<T>
         , virtual operations< ::elm_interface_atspi_widget_action >::template type<T>
   {
      virtual void group_add(::elm::radio group_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_radio_group_add(::efl::eolian::to_c(group_)));
      }

      virtual int state_value_get()
      {
         int _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_radio_state_value_get());
            return _tmp_ret;
      }

      virtual void state_value_set(int value_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_radio_state_value_set(value_));
      }

      virtual int value_get()
      {
         int _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_radio_value_get());
            return _tmp_ret;
      }

      virtual void value_set(int value_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_radio_value_set(value_));
      }

      virtual void value_pointer_set(int * valuep_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_radio_value_pointer_set(valuep_));
      }

      virtual ::evas::object selected_object_get()
      {
         Evas_Object * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_radio_selected_object_get());
            return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

   };
};


template<>
struct operation_description_class_size< ::elm::radio >
{
   static constexpr int value = 
#if defined(RADIO_PROTECTED) && defined(RADIO_BETA)
      7
#elif defined(RADIO_PROTECTED)
      7
#elif defined(RADIO_BETA)
      7
#else
      7
#endif
      + operation_description_class_size<::elm::layout >::value      + operation_description_class_size<::elm_interface_atspi_widget_action >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::radio>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_radio_group_add_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_radio_group_add);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_radio_state_value_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_radio_state_value_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_radio_state_value_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_radio_state_value_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_radio_value_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_radio_value_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_radio_value_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_radio_value_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_radio_value_pointer_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_radio_value_pointer_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_radio_selected_object_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_radio_selected_object_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::layout>(), &ops[operation_description_class_size< ::elm::radio >::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::elm_interface_atspi_widget_action>(), &ops[operation_description_class_size< ::elm::radio >::value + operation_description_class_size<::elm::layout>::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::radio>)
{
   return (ELM_RADIO_CLASS);
}

} } }

/// @endcond

